<?php
class ControllerPaymentEtpv extends Controller {
	protected function index() {
    	$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_back'] = $this->language->get('button_back');

        if (!$this->config->get('etpv_test')) {
            $this->data['action'] = 'http://www.e-tpv.com/e-tpv/html/etpvpago.php';
        } else {
            $this->data['action'] = 'http://pruebas.e-tpv.com/e-tpv/html/etpvpago.php';
        }      

		$this->load->model('checkout/order');

        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		$importe = $this->currency->format($order_info['total'], 'EUR', '', FALSE)*100;

		$this->data['etpv_username'] = $this->config->get('etpv_merchant');
		$this->data['etpv_importe'] = $importe;
		$this->data['etpv_concept'] = $order_info['payment_firstname'] ." ".$order_info['payment_lastname']." (".$order_info['email'].")";
		$this->data['etpv_order_ref'] =  $this->session->data['order_id'];
		$this->data['etpv_clientconcept'] = $this->session->data['order_id'] . ' - ' . $order_info['payment_firstname'] . ' ' . $order_info['payment_lastname'];
//		$this->data['Idioma'] = $this->language->getCode();
        $this->data['config_result'] = $this->url->http('payment/etpv/callback');;
        $this->data['config_recibo'] = $this->url->https('payment/etpv/recibo');
        $this->data['etpv_firma'] = md5($this->config->get('etpv_merchant').$this->session->data['order_id'].$importe.md5($this->config->get('etpv_password')));

		$this->data['back'] = $this->url->https('checkout/payment');
		
		$this->id       = 'payment';
        if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/etpv.tpl')) {
            $this->template = $this->config->get('config_template') . '/template/payment/etpv.tpl';
        } else {
            $this->template = 'default/template/payment/etpv.tpl';
        }
		
		$this->render();		
	}

    public function callback() {
        $origen_valido = array_merge(gethostbynamel('e-tpv.com'),gethostbynamel('zhenit.com'));

        if(!in_array($_SERVER['REMOTE_ADDR'],$origen_valido)){ die("hACKING ATTEMPT, ORIGEN NO VÁLIDO");}

        if(!isset($this->request->post['etpv_order_ref'])) die("no se puede procesar pedido sin identificador");

        $order_id = $this->request->post['etpv_order_ref'];

        $this->load->model('checkout/order');
                
        $order_info = $this->model_checkout_order->getOrder($order_id);
        
        if ($order_info) {
          $importe = $this->currency->format($order_info['total'], 'EUR', '', FALSE)*100;
          if($this->request->post['etpv_firma_server']!=md5($this->config->get('etpv_merchant').$order_id.$importe.md5($this->config->get('etpv_password')).$this->request->post['psztxnid'])){
            die("Firma no válida, procedencia del mensaje no verificada");
          }        
          if ($this->request->post['result'] == 0) {
            $this->model_checkout_order->confirm($order_id, $this->config->get('etpv_order_status_id'));
          }
        }
    }

    public function recibo() {
        $order_id = $this->request->post['etpv_order_ref'];

        $this->load->model('checkout/order');
                
        $order_info = $this->model_checkout_order->getOrder($order_id);

        if ($order_info['order_status_id']==$this->config->get('etpv_order_status_id')) {
          header("location: ".$this->url->https('checkout/success'));
        }else{
          header("location: ".$this->url->https('checkout/payment'));
        }
    }

}
?>
